---
title: XRInputSourcesChangeEvent
slug: Web/API/XRInputSourcesChangeEvent
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Interface
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourcesChangeEvent
  - augmented
  - events
  - inputsourceschange
---
<p>{{APIRef("WebXR Device API")}} {{SecureContext_Header}}</p>

<p>The WebXR Device API interface <code><strong>XRInputSourcesChangeEvent</strong></code> is used to represent the {{domxref("XRSession.inputsourceschange_event", "inputsourceschange")}} event sent to an {{domxref("XRSession")}} when the set of available WebXR input controllers changes.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("XRInputSourcesChangeEvent.XRInputSourcesChangeEvent", "XRInputSourcesChangeEvent()")}}</dt>
 <dd>Creates and returns a new <code>XRInputSourcesChangeEvent</code> object configured as indicated by the given {{domxref("XRInputSourcesChangeEventInit")}} object. The specified type must be <code>inputsourceschange</code>, which is the only event that uses this interface.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("XRInputSourcesChangeEvent.added", "added")}} {{ReadOnlyInline}}</dt>
 <dd>An array of zero or more {{domxref("XRInputSource")}} objects, each representing an input device which has been newly connected or enabled for use.</dd>
 <dt>{{domxref("XRInputSourcesChangeEvent.removed", "removed")}} {{ReadOnlyInline}}</dt>
 <dd>An array of zero or more {{domxref("XRInputSource")}} objects representing the input devices newly connected or enabled for use.</dd>
 <dt>{{domxref("XRInputSourcesChangeEvent.session", "session")}} {{ReadOnlyInline}}</dt>
 <dd>The {{domxref("XRSession")}} to which this input source change event is being directed.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>While <code>XRInputSourcesChangeEvent</code> defines no methods of its own, it inherits methods from its parent interface, {{domxref("Event")}}.</em></p>

<h2 id="Event_types">Event types</h2>

<dl>
 <dt>{{domxref("XRSession.inputsourceschange_event", "inputsourceschange")}}</dt>
 <dd>Delivered to the {{domxref("XRSession")}} when the set of input devices available to it changes.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example shows how to set up an event handler which uses <code>inputsourceschange</code> events to detect newly-available pointing devices and to load their models in preparation to display them in the next animation frame.</p>

<pre class="brush: js">xrSession.addEventListener("inputsourceschange", onInputSourcesChange);

function onInputSourcesChange(event) {
  for (let input of event.added) {
    if (input.targetRayMode == "tracked-pointer") {
      loadControllerMesh(input);
    }
  }
}
</pre>

<p>You can also add a handler for <code>inputsourceschange</code> events by setting the {{domxref("XRSession.oninputsourceschange", "oninputsourceschange")}} event handler:</p>

<pre class="brush: js">xrSession.oninputsourceschange = onInputSourcesChange;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrinputsourceschangeevent","XRInputSourcesChangeEvent")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRInputSourcesChangeEvent")}}</div>
